Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_gtk.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_gtk.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_gtk.cc	(revision 4139)
@@ -222,5 +222,5 @@
     return this;
 
-  if (this->isOption < 0 && static_cast<Packer*>(this)->down)
+  if (this->optionType < GUI_NOTHING && static_cast<Packer*>(this)->down)
     {
       Widget* tmp = static_cast<Packer*>(this)->down->findWidgetByName(name, depth+1);
@@ -243,5 +243,5 @@
 {
   function(this);
-  if (this->isOption < 0)
+  if (this->optionType < GUI_NOTHING)
     {
       static_cast<Packer*>(this)->down->walkThrough(function, depth+1);
@@ -261,5 +261,5 @@
 {
   function(this, data);
-  if (this->isOption < 0)
+  if (this->optionType < GUI_NOTHING)
     {
       static_cast<Packer*>(this)->down->walkThrough(function, data, depth+1);
@@ -275,7 +275,7 @@
 void Widget::listOptionsAndGroups(Widget* widget)
 {
-  if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
+  if (widget->optionType < GUI_NOTHING && static_cast<Packer*>(widget)->groupName)
     PRINT(0)("[%s]\n", static_cast<Packer*>(widget)->groupName);
-  if (widget->isOption >= 1)
+  if (widget->optionType > GUI_NOTHING)
     {
       Widget::listOptions(widget);
@@ -289,5 +289,5 @@
 void Widget::listOptions(Widget* widget)
 {
-  if(widget->isOption >= 1)
+  if(widget->optionType > GUI_NOTHING)
     PRINT(0)("  %s is %s\n", static_cast<Option*>(widget)->title, static_cast<Option*>(widget)->save());
 }
@@ -301,5 +301,5 @@
 {
   
-  if (widget->isOption >= 1)
+  if (widget->optionType > GUI_NOTHING)
     {
       int* count =(int*)data;
@@ -308,4 +308,44 @@
 	       static_cast<Option*>(widget)->title,
 	       static_cast<Option*>(widget)->save());
+    }
+}
+
+/** 
+    \brief This is for listing the options of "widget"
+    \param widget specifies the widget that should be listed
+    \param data A Counter, that always knows how many Options have been found yet.
+*/
+void Widget::printHelp(Widget* widget)
+{
+  int helpLen=0;
+
+  if (widget->optionType > GUI_NOTHING)
+    {
+      Option* option = (Option*)widget;
+      if (option->flagName || option->flagNameShort)
+	{
+	  PRINT(0)("  ");
+	  if (option->flagNameShort)
+	    {
+	      PRINT(0)("-%s", option->flagNameShort);
+	      helpLen += strlen(option->flagNameShort)+1;
+	    }
+	  if (option->flagName)
+	    {
+	      if (helpLen > 0)
+		{
+		  PRINT(0)("|");
+		  helpLen++;
+		}
+	      PRINT(0)("--%s:", option->flagName);
+	      helpLen += strlen(option->flagName)+2;
+	    }
+	  while ((helpLen ++) < 29)
+	    PRINT(0)(" ");
+	  if (option->shortDescription)
+	    PRINT(0)("%s\n", option->shortDescription);
+	  else
+	    PRINT(0)("\n");
+	}
     }
 }
@@ -320,5 +360,5 @@
 Widget* Widget::findOptionByNumber(int* number, unsigned int depth)
 {
-  if (isOption > 0)
+  if (optionType > GUI_NOTHING)
     {
       --*number;
@@ -328,5 +368,5 @@
 	}
     }
-  if (this->isOption < 0 && static_cast<Packer*>(this)->down)
+  if (this->optionType < GUI_NOTHING && static_cast<Packer*>(this)->down)
     {
       Widget* tmp = static_cast<Packer*>(this)->down->findOptionByNumber(number, depth+1);
@@ -346,5 +386,5 @@
 void Widget::listGroups(Widget* widget)
 {
-  if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
+  if (widget->optionType < GUI_NOTHING && static_cast<Packer*>(widget)->groupName)
     PRINT(0)("[%s]\n", static_cast<Packer*>(widget)->groupName);
 }
@@ -358,5 +398,5 @@
 {
   int* count = (int*)data;
-  if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
+  if (widget->optionType < GUI_NOTHING && static_cast<Packer*>(widget)->groupName)
     PRINT(0)("%d: [%s]\n", ++*count, static_cast<Packer*>(widget)->groupName);
 }
@@ -369,5 +409,5 @@
 Widget* Widget::findGroupByNumber(int* number, unsigned int depth)
 {
-  if (isOption < 0 && static_cast<Packer*>(this)->groupName)
+  if (optionType < GUI_NOTHING && static_cast<Packer*>(this)->groupName)
     {
       --*number;
@@ -377,5 +417,5 @@
 	}
     }
-  if (this->isOption < 0 && static_cast<Packer*>(this)->down)
+  if (this->optionType < GUI_NOTHING && static_cast<Packer*>(this)->down)
     {
       Widget* tmp = static_cast<Packer*>(this)->down->findGroupByNumber(number, depth+1);
@@ -395,5 +435,5 @@
 void Widget::setOptions(Widget* widget)
 {
-  if (widget->isOption >= 1)
+  if (widget->optionType > GUI_NOTHING)
     static_cast<Option*>(widget)->redraw();
 }
@@ -406,5 +446,5 @@
 void Widget::redrawOptions(Widget* widget)
 {
-  if (widget->isOption >= 1)
+  if (widget->optionType > GUI_NOTHING)
     static_cast<Option*>(widget)->redraw();
 }
@@ -415,5 +455,5 @@
 void Widget::flagCheck(Widget* widget, void* flagName)
 {
-  if (widget->isOption>=1)
+  if (widget->optionType > GUI_NOTHING)
     {      
       Option* option =(Option*)widget;
@@ -567,5 +607,5 @@
 Container::Container(void)
 {
-  this->isOption = -1;
+  this->optionType = GUI_CONTAINER;
 }
 
@@ -595,5 +635,5 @@
     }
   else
-    PRINTF(1)("You tried to put more than one Widget into a Container. \nNot including this item.\nThis is only possible with Boxes.\n");
+    PRINTF(2)("You tried to put more than one Widget into a Container. \nNot including this item.\nThis is only possible with Boxes.\n");
 }
 
@@ -772,5 +812,5 @@
    \brief Creates a new Frame with name title
 */
-Frame::Frame(char* frameName)
+Frame::Frame(const char* frameName)
 {
 #ifdef HAVE_GTK2
@@ -778,5 +818,5 @@
   gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
 #endif /* HAVE_GTK2 */
-  if (title)
+  if (frameName)
     this->setTitle(frameName);
 }
@@ -801,5 +841,5 @@
   strcpy(this->title, title);
 #ifdef HAVE_GTK2
-  gtk_frame_set_label(GTK_FRAME(widget), title);
+  gtk_frame_set_label(GTK_FRAME(widget), this->title);
 #endif /* HAVE_GTK2 */
 }
@@ -814,6 +854,4 @@
 EventBox::EventBox(const char* eventBoxName)
 {
-  this->isOption = -1;
-
 #ifdef HAVE_GTK2
   this->widget = gtk_event_box_new();
@@ -842,5 +880,5 @@
 Box::Box(char boxtype)
 {
-  this->isOption = -2;
+  this->optionType = GUI_BOX;
 
 #ifdef HAVE_GTK2
@@ -1053,7 +1091,7 @@
    \param buttonName sets the Name of the Button
 */
-Button::Button(char* buttonName)
-{
-  isOption = 0;
+Button::Button(const char* buttonName)
+{
+  this->optionType = GUI_NOTHING;
 
 #ifdef HAVE_GTK2
@@ -1115,5 +1153,5 @@
 CheckButton::CheckButton(const char* buttonName)
 {
-  this->isOption = 1;
+  this->optionType = GUI_BOOL;
 
 #ifdef HAVE_GTK2
@@ -1179,6 +1217,7 @@
   if ((this->value = atoi(tmpChar))=!0)
     this->value = 1;
-#endif /* HAVE_GTK2 */
+
   PRINT(0)("%s set to: %d\n", this->title, this->value);
+#endif /* HAVE_GTK2 */
 }
 
@@ -1205,5 +1244,5 @@
 Slider::Slider(const char* slidername, int start, int end)
 {
-  this->isOption = 2;
+  this->optionType = GUI_INT;
 
   this->start = start;
@@ -1264,6 +1303,7 @@
   if (this->value <= this->start)
     this->value = this->start;
-#endif /* HAVE_GTK2 */
+
   PRINT(0)("%s set to: %d\n",this->title, this->value);
+#endif /* HAVE_GTK2 */
 }
 
@@ -1329,5 +1369,5 @@
 void Menu::init(void)
 {
-  this->isOption = 2;
+  this->optionType = GUI_INT;
   this->firstItem = NULL;
 
@@ -1372,7 +1412,7 @@
     {
       this->value = 0;
-      PRINTF(2)("Sorry, but %s has not been found in the Itemlist of %s\n", loadString, this->title);
-    }
-  PRINTF(4)( "Loading %s: setting to %d\n", this->title, this->value); 
+      PRINTF(2)("%s has not been found in the Itemlist of %s\n", loadString, this->title);
+    }
+  PRINTF(5)( "Loading %s: setting to %d\n", this->title, this->value); 
   this->redraw();
 }
@@ -1431,5 +1471,5 @@
 
 #endif /* HAVE_GTK2 */
-  PRINT(4)("%s set to: %d\n", this->title, this->value);
+  PRINT(5)("%s set to: %d\n", this->title, this->value);
 }
 
@@ -1443,5 +1483,5 @@
 OptionLabel::OptionLabel(const char* label, const char* value)
 {
-  this->isOption = 5;
+  this->optionType = GUI_CHAR_ARRAY;
   cValue = NULL;
 
@@ -1474,7 +1514,6 @@
   this->cValue = new char [strlen(newValue)+1];
   strcpy(this->cValue, newValue);
-#ifdef HAVE_GTK2
-  gtk_label_set_text(GTK_LABEL(this->widget), this->cValue);
-#endif /* HAVE_GTK2 */
+
+  this->redraw();
 }
 
@@ -1485,5 +1524,5 @@
 {
 #ifdef HAVE_GTK2
-  gtk_label_set_text(GTK_LABEL(widget), title);
+  gtk_label_set_text(GTK_LABEL(widget), cValue);
 #endif /* HAVE_GTK2 */
 }
@@ -1495,5 +1534,5 @@
 {
 #ifdef HAVE_GTK2
-  this->cValue =(char*)gtk_label_get_text(GTK_LABEL(this->widget));
+  this->cValue = (char*)gtk_label_get_text(GTK_LABEL(this->widget));
 #else /* HAVE_GTK2 */
   PRINT(0)("\nPlease give me a new input for %s: ", this->title);
@@ -1521,5 +1560,5 @@
 void OptionLabel::load(char* loadString)
 {
-  PRINTF(4)("Loading %s: setting to %s\n", this->title, loadString); 
+  PRINTF(5)("Loading %s: setting to %s\n", this->title, loadString); 
   this->setValue(loadString);
 }
@@ -1534,5 +1573,5 @@
 Label:: Label(const char* text)
 {
-  this->isOption = 0;
+  this->optionType = GUI_NOTHING;
   
 #ifdef HAVE_GTK2
@@ -1630,5 +1669,5 @@
 ProgressBar::ProgressBar(const char* label)
 {
-  this->isOption = 0;
+  this->optionType = GUI_NOTHING;
   this->progress = 0.0;
   this->totalSize = 0.0;
@@ -1671,5 +1710,5 @@
 #ifdef HAVE_GTK2
   gtk_progress_set_value(GTK_PROGRESS(widget), this->progress*100.0/this->totalSize);
-  PRINTF(4)("Progress: %f%%\n", this->progress*100.0/this->totalSize);
+  PRINTF(5)("Progress: %f%%\n", this->progress*100.0/this->totalSize);
 #else /* HVE_GTK2 */
   PRINT(0)("Progress: %f%%\n", this->progress*100.0/this->totalSize);
@@ -1729,5 +1768,5 @@
 void Image::init(const char* name)
 {
-  isOption = 0;
+  optionType = GUI_NOTHING;
 
   if (this->title)
@@ -1736,2 +1775,167 @@
   strcpy(this->title, name);
 }
+
+
+/////////////////
+/* FILE DIALOG */
+/////////////////
+/**
+   \brief Creates a new FileDialog
+   \param fileDialogName a Name for the Dialog
+*/
+FileDialog::FileDialog(const char* fileDialogName)
+{
+  this->optionType = GUI_NOTHING;
+  this->isOpen = false;
+  this->changeOption = NULL;
+  this->openUpButton = NULL;
+  this->okObject = NULL;
+  this->okFunc = NULL;
+
+#ifdef HAVE_GTK2
+  this->widget = gtk_file_selection_new(fileDialogName);
+
+  gtk_file_selection_set_select_multiple(GTK_FILE_SELECTION (this->widget), FALSE);
+
+  g_signal_connect(GTK_FILE_SELECTION (this->widget)->cancel_button,
+                     "button_release_event",
+                     G_CALLBACK (FileDialog::dialogClose),
+                     this);
+  g_signal_connect(GTK_FILE_SELECTION (this->widget),
+                     "delete_event",
+                     G_CALLBACK (FileDialog::dialogClose),
+                     this);
+  g_signal_connect(GTK_FILE_SELECTION (this->widget)->ok_button,
+                     "button_release_event",
+                     G_CALLBACK (FileDialog::dialogOK),
+                     this);
+#endif /* HAVE_GTK2 */
+  if (fileDialogName)
+    this->setTitle(fileDialogName);
+}
+
+/**
+   \brief destructs a FileDialog
+*/
+FileDialog::~FileDialog(void)
+{
+  PRINTF(5)("deleting FileDialog %s\n", this->title);
+}
+
+void FileDialog::setChangeOption(OptionLabel* changeOption)
+{
+  this->changeOption = changeOption;
+}
+
+void FileDialog::setOKFunc(void* okObject, bool(*function)(const char* , void*))
+{
+  this->okObject = okObject;
+  this->okFunc = function;
+}
+
+
+void FileDialog::setOpenUpButton(Button* openUpButton)
+{
+  this->openUpButton = openUpButton;
+
+  openUpButton->connectSignal("button_release_event", this, FileDialog::dialogOpen);
+}
+
+
+void FileDialog::setDefaultFileName(const char* defaultFileName)
+{
+#ifdef HAVE_GTK2
+  gtk_file_selection_set_filename (GTK_FILE_SELECTION(this->widget), defaultFileName);
+#endif /* HAVE_GTK2 */
+}
+
+void FileDialog::setMask(const char* mask)
+{
+#ifdef HAVE_GTK2
+  gtk_file_selection_complete(GTK_FILE_SELECTION(this->widget), mask);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief disables the File Operator Buttons
+*/
+void FileDialog::disableFileOpts(void)
+{
+#ifdef HAVE_GTK2
+  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(this->widget));
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief The ok-button has been pressed
+*/
+void FileDialog::okEvent(void)
+{
+  if (this->okFunc)
+    {
+#ifdef HAVE_GTK2
+      if(this->okFunc((const char*)gtk_file_selection_get_filename(GTK_FILE_SELECTION(this->widget)), this->okObject))
+	 this->close();
+#endif /* HAVE_GTK2 */
+    }
+  else if (this->changeOption)
+    {
+#ifdef HAVE_GTK2
+      changeOption->setValue(gtk_file_selection_get_filename(GTK_FILE_SELECTION(this->widget)));
+#endif /* HAVE_GTK2 */
+      this->close();
+    }
+  else
+    this->close();
+}
+
+/**
+   \biref opens up the FileDialog-Window
+*/
+void FileDialog::open(void)
+{
+  isOpen = true;
+#ifdef HAVE_GTK2
+  gtk_widget_show_all(this->widget);
+  gtk_grab_add(this->widget);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \closes the FileDialog-Window
+*/
+void FileDialog::close(void)
+{
+  this->isOpen = false;
+#ifdef HAVE_GTK2
+  gtk_grab_remove(this->widget);
+  gtk_widget_hide(this->widget);
+#endif /* HAVE_GTK2 */
+}
+
+#ifdef HAVE_GTK2
+gint FileDialog::dialogOK(GtkWidget* widget, GdkEvent* event, void* dialog)
+{
+  static_cast<FileDialog*>(dialog)->okEvent();
+}
+#else /* HAVE_GTK2 */
+int FileDialog::dialogOK(void* widget, void* event, void* dialog){}
+#endif /* HAVE_GTK2 */
+
+#ifdef HAVE_GTK2
+gint FileDialog::dialogOpen(GtkWidget* widget, GdkEvent* event, void* dialog)
+{
+  static_cast<FileDialog*>(dialog)->open();
+}
+#else /* HAVE_GTK2 */
+int FileDialog::dialogOpen(void* widget, void* event, void* dialog){}
+#endif /* HAVE_GTK2 */
+
+#ifdef HAVE_GTK2
+gint FileDialog::dialogClose(GtkWidget* widget, GdkEvent* event, void* dialog)
+{
+  static_cast<FileDialog*>(dialog)->close();
+}
+#else /* HAVE_GTK2 */
+int FileDialog::dialogClose(void* widget, void* event, void* dialog){}
+#endif /* HAVE_GTK2 */
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_gtk.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_gtk.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_gtk.h	(revision 4139)
@@ -11,4 +11,5 @@
 
 #include "debug.h"
+#include "globals.h"
 
 #ifdef HAVE_GTK2
@@ -28,9 +29,10 @@
 #include <gtk/gtkeventbox.h>
 #include <gtk/gtkprogressbar.h>
+#include <gtk/gtkfilesel.h>
 #endif /* HAVE_GTK2 */
 
 // enumerator for different GuiOption-Types
-enum GUI_OPTION {GUI_CONTAINER = -2,
-		 GUI_BOX = -1,
+enum GUI_OPTION {GUI_BOX = -2,
+		 GUI_CONTAINER = -1,
 		 GUI_NOTHING = 0,
 		 GUI_BOOL = 1,
@@ -63,14 +65,15 @@
   void walkThrough(void(*function)(Widget*), unsigned int depth);
   void walkThrough(void(*function)(Widget*, void*), void* data, unsigned int depth);
-  static void listOptionsAndGroups(Widget* widget);
-  static void listOptions(Widget* widget);
-  static void listOptions(Widget* widget, void* data);
-  Widget* findOptionByNumber(int* number, unsigned int depth);
-  static void listGroups(Widget* widget);
-  static void listGroups(Widget* widget, void* data);
-  Widget* findGroupByNumber(int* number, unsigned int depth);
-  static void setOptions(Widget* widget);
-  static void redrawOptions(Widget* widget);
-  static void flagCheck(Widget* widget, void* flagName);
+   static void listOptionsAndGroups(Widget* widget);
+   static void listOptions(Widget* widget);
+   static void listOptions(Widget* widget, void* data);
+   Widget* findOptionByNumber(int* number, unsigned int depth);
+   static void listGroups(Widget* widget);
+   static void listGroups(Widget* widget, void* data);
+   static void printHelp(Widget* widget);
+   Widget* findGroupByNumber(int* number, unsigned int depth);
+   static void setOptions(Widget* widget);
+   static void redrawOptions(Widget* widget);
+   static void flagCheck(Widget* widget, void* flagName);
   
 #ifdef HAVE_GTK2
@@ -103,6 +106,5 @@
 #endif /* HAVE_GTK2 */
 
-  int isOption;                     //!< with this Paramenter one can set the option-type: -2:Container, -1: Box, 0: not an Option, 1: Bool-option, 2: int-option, 3: float option, 4:char option, 5: char* option
-  
+  GUI_OPTION optionType;            //!< The Type of the Widget.
   char* title;                      //!< The name of the Widget. Some do display it, Options need it to save;
 };
@@ -141,4 +143,5 @@
   Container(void);
   virtual ~Container(void);
+
   void setBorderWidth(int borderwidth);
   void fill(Widget* lowerWidget);
@@ -184,5 +187,5 @@
 {
  public:
-  Frame(char* frameName = NULL);
+  Frame(const char* frameName = NULL);
   virtual ~Frame(void);
 
@@ -262,5 +265,5 @@
 {
  public:
-  Button(char* buttonName = NULL);
+  Button(const char* buttonName = NULL);
   virtual ~Button(void);
 
@@ -358,4 +361,19 @@
 };
 
+//! A EntryField is a TextEntry field, for putting some text into.
+class EntryField : public Option
+{
+ public:
+  EntryField(const char* name = NULL);
+  virtual ~EntryField(void);
+  
+  void setValue(const char* newValue);
+  virtual char* save(void);
+  virtual void load(char* loadString);
+  
+  virtual void redraw(void);
+  virtual void changeOption(void);
+};
+
 //! A label is a Widget, that displays a text
 class Label : public Widget
@@ -405,5 +423,39 @@
 };
 
-//gint orxonox_gui_quit(GtkWidget* widget, GdkEvent* event, gpointer data);
+//! A FileDialog is a window with wich one can select a File
+class FileDialog : public Widget
+{
+ private:
+  OptionLabel* changeOption;
+  Button* openUpButton;
+  bool isOpen;
+  bool (*okFunc)(const char* , void*);
+  void* okObject;
+
+ public:
+  FileDialog(const char* fileDialogName);
+  virtual ~FileDialog(void);
+
+  void setChangeOption(OptionLabel* changeOption);
+  void setOKFunc(void* okObject, bool(*function)(const char* , void*));
+  void setOpenUpButton(Button* openUpButton);
+  void setDefaultFileName(const char* defaultFileName);
+  void setMask(const char* mask);
+  void disableFileOpts(void);
+
+  void okEvent();
+  void open();
+  void close();
+
+#ifdef HAVE_GTK2
+  static gint dialogOK(GtkWidget* widget, GdkEvent* event, void* dialog);
+  static gint dialogOpen(GtkWidget* widget, GdkEvent* event, void* dialog);
+  static gint dialogClose(GtkWidget* widget, GdkEvent* event, void* dialog);
+#else /* HAVE_GTK2 */
+  static int dialogOK(void* widget, void* event, void* dialog);
+  static int dialogOpen(void* widget, void* event, void* dialog);
+  static int dialogClose(void* widget, void* event, void* dialog);
+#endif /* HAVE_GTK2 */
+};
 
 #endif /* _GUI_GTK_H */
